/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// OperationRequestFilter - struct for OperationRequestFilter
type OperationRequestFilter struct {
	FilterRequest *FilterRequest
}

// FilterRequestAsOperationRequestFilter is a convenience function that returns FilterRequest wrapped in OperationRequestFilter
func FilterRequestAsOperationRequestFilter(v *FilterRequest) OperationRequestFilter {
	return OperationRequestFilter{
		FilterRequest: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *OperationRequestFilter) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FilterRequest
	err = newStrictDecoder(data).Decode(&dst.FilterRequest)
	if err == nil {
		jsonFilterRequest, _ := json.Marshal(dst.FilterRequest)
		if string(jsonFilterRequest) == "{}" { // empty struct
			dst.FilterRequest = nil
		} else {
			match++
		}
	} else {
		dst.FilterRequest = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FilterRequest = nil

		return fmt.Errorf("data matches more than one schema in oneOf(OperationRequestFilter)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(OperationRequestFilter)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src OperationRequestFilter) MarshalJSON() ([]byte, error) {
	if src.FilterRequest != nil {
		return json.Marshal(&src.FilterRequest)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *OperationRequestFilter) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FilterRequest != nil {
		return obj.FilterRequest
	}

	// all schemas are nil
	return nil
}

type NullableOperationRequestFilter struct {
	value *OperationRequestFilter
	isSet bool
}

func (v NullableOperationRequestFilter) Get() *OperationRequestFilter {
	return v.value
}

func (v *NullableOperationRequestFilter) Set(val *OperationRequestFilter) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequestFilter) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequestFilter) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequestFilter(val *OperationRequestFilter) *NullableOperationRequestFilter {
	return &NullableOperationRequestFilter{value: val, isSet: true}
}

func (v NullableOperationRequestFilter) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequestFilter) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
